/*
 * ProviewR   Open Source Process Control.
 * Copyright (C) 2005-2019 SSAB EMEA AB.
 *
 * This file is part of ProviewR.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ProviewR. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking ProviewR statically or dynamically with other modules is
 * making a combined work based on ProviewR. Thus, the terms and
 * conditions of the GNU General Public License cover the whole
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * ProviewR give you permission to, from the build function in the
 * ProviewR Configurator, combine ProviewR with modules generated by the
 * ProviewR PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every
 * copy of the combined work is accompanied by a complete copy of
 * the source code of ProviewR (the version used to produce the
 * combined work), being distributed under the terms of the GNU
 * General Public License plus this exception.
 */

#include "cow_qt_helpers.h"

#include "glow_colpalctx.h"
#include "glow_colpalwidget_qt.h"
#include "glow_scroll_widget_qt.h"

static void scroll_callback(glow_sScroll* data)
{
  widget_sScroll* scroll_data = (widget_sScroll*)data->scroll_data;
  QtScrollWidgetGlow* colpal = ((QtScrollWidgetGlow*)scroll_data->parent);

  initOneShotTimer(colpal->scroll_timerid, SLOT(scroll_callback_cb()), 200);

  colpal->scroll_data = *data;
}

static int colpal_init_proc(QWidget* w, GlowCtx* fctx, void* client_data)
{
  QtScrollWidgetGlow* colpal = ((QtScrollWidgetGlow*)w);
  ColPalCtx* ctx = (ColPalCtx*)colpal->parent_ctx;

  if (((QtScrollWidgetGlow*)w)->scroll_h) {
    widget_sScroll* scroll_data = new widget_sScroll();
    scroll_data->parent = w;
    scroll_data->scroll_h = colpal->scroll_h;
    scroll_data->scroll_v = colpal->scroll_v;
    scroll_data->scroll_h_managed = 1;
    scroll_data->scroll_v_managed = 1;

    ctx->register_scroll_callback((void*)scroll_data, scroll_callback);
  }

  ctx->configure();

  if (colpal->init_proc) {
    return (colpal->init_proc)(ctx, client_data);
  } else {
    return 1;
  }
}

QWidget* scrolledcolpalwidgetqt_new(
    int (*init_proc)(GlowCtx* ctx, void* client_data), void* client_data,
    QWidget** colpalwidget)
{
  QtScrollWidgetGlow* w = new QtScrollWidgetGlow();
  *colpalwidget = w;
  return w->initScroll(
      glow_eCtxType_ColPal, init_proc, client_data, colpal_init_proc);
}